<%@ page import="com.agillic.core.clm.condition.APICondition" %>
<%@ page import="com.agillic.portletsdk.condition.APIConditionFactory" %>
<%@ page import="com.agillic.portletsdk.condition.LogicalConditionOR" %>
<%@ page import="com.agillic.portletsdk.condition.SimpleCondition" %>
<%@ page import="java.util.*" %>
<%@ taglib prefix="sdk" uri="http://agillic.com/jsp/sdk/1.0" %>
<%@ taglib prefix="inp" uri="http://agillic.com/jsp/sdkinput/1.0" %>
<sdk:action>
    <%
        //Get the inputted values
        Map<String,String> map = flow.getEnteredValues();
        List<APICondition> conditions = new ArrayList<APICondition>();

        //Run through the values
        Set<Map.Entry<String,String>> entries = map.entrySet();
        for (Iterator<Map.Entry<String, String>> iterator = entries.iterator(); iterator.hasNext();) {
            Map.Entry<String, String> entry = iterator.next();
            //We only want to search for non-blank input
            if(entry.getValue()!=null && entry.getValue().length()>0) {
                //We are doing it as prefix searches
                SimpleCondition condition = APIConditionFactory.createSimpleCondition(entry.getKey(), "LIKE", entry.getValue() + "*");
                conditions.add(condition);
            }
        }
        if(conditions.size()>0) {
            //We did have some conditions - let's do an or search (max 10 results)
            LogicalConditionOR or = APIConditionFactory.createLogicalConditionOR(conditions);
            List<Map<String, String>> maps = api.listUsersByCondition(or, 10);

            if(maps!=null && maps.size()>0) {
                //We found someone
                if(maps.size()==1) {
                    //Only one hit - we assume it was the one we wanted and select that user right away

                    //For each match we have a map of person data - in addition to the personData there is an entry called 'userId', this is the internal id
                    String internalId = maps.get(0).get("userId");

                    //Impersonate the user - i.e have all api's think that the given user is actually the one logged in
                    api.impersonateUser(internalId);

                    //Create the url to use to go the the page with uri "overview"
                    String s = web.generateMenuItemUrl("/overview");
                    portletResponse.sendRedirect(s);
                } else {
                    //We had more than one response let us show them to the admin
                    request.setAttribute("foundUsers",map);
                }
            } else {
                request.removeAttribute("foundUsers");
            }
        } else {
            request.removeAttribute("foundUsers");
        }

    %>
</sdk:action>
<sdk:render>
    <inp:form next="index">
        <label for="email">Email</label>
        <inp:text name="email"/>

        <label for="msisdn">Phone</label>
        <inp:text name="msisdn"/>

        <label for="accountno">Account number</label>
        <inp:text name="accountno"/>

        <input type="submit" value="Search">
    </inp:form>

    <%
        List<Map<String,String>> foundUsers = (List<Map<String,String>>) request.getAttribute("foundUsers");
        //Checking if we have some matches and if so list them
        if(foundUsers!=null && foundUsers.size()>0) {
    %>
    <table>
        <thead>
            <tr>
                <th>Email</th>
                <th>Phone</th>
                <th>Account number</th>
                <th>Name</th>
            </tr>
        </thead>
        <tbody>
            <%
                for (Iterator<Map<String, String>> iterator = foundUsers.iterator(); iterator.hasNext();) {
                    Map<String, String> map = iterator.next();
            %>
            <tr>
                <td><%=map.get("EMAIL")%></td>
                <td><%=map.get("MSISDN")%></td>
                <td><%=map.get("ACCOUNT_NO")%></td>
                <td><%=map.get("FIRSTNAME")+" "+map.get("LASTNAME")%></td>
            </tr>
            <%
                }
            %>
        </tbody>
    </table>
    <%
        }
    %>
</sdk:render>